/*
 * SubCl.java
 *
 * Created on 03 October 2005, 15:59
 */

package compr;
import java.util.*;
import ica.*;
import Jama.*;
import visu.VisuSimple;
import visu.Visu2D;

/**
 *
 * @author Administrator
 */
public class SubCl {
    int sampleSize;
    DB db;
    //Cluster[] cl;
    Vector cl;
    int dim; //ursprngliche dim.
    
    
    
    /** Creates a new instance of SubCl */
    public SubCl(DB db) {
        this.db = db;
        //this.sampleSize = db.store.length/10;
        this.sampleSize = 10;
        this.dim = db.store[0].coord.length;
        cl = new Vector();
    }
    
    public double[][] getMeans(){
        double[][] means = new double[cl.size()][dim];
        for(int i = 0; i < cl.size(); i++)
            for(int j = 0; j < dim; j++){
            Cluster akt = (Cluster)cl.elementAt(i);
            means[i][j] = akt.mean[j];
            }
        return means;
    }
    
    public Cluster[] getClusters(){
        Cluster[] c = new Cluster[cl.size()];
        for(int i = 0; i < cl.size(); i++){
            Cluster akt = (Cluster)cl.elementAt(i);
            c[i] = akt;
        }
        return c;
    }
    
    
    
    private DataObject[] knn(DataObject[] data, DataObject d, int k){
        double[] erg = new double[k];        //Array der Grsse MinPts anlegen
        for(int i=0; i<k; i++) {
            erg[i] = Double.MAX_VALUE;  //alle auf Max_Value setzen.
        }
        DataObject[] result = new DataObject[k];
        for(int i=0; i < data.length; i++) {   //Durchlauf alle Datenobjekte
            DataObject akt = data[i];
            if(akt.number != d.number){
                double dist = d.distance(data[i]); //Distanz zum i-ten Datenobjekt
                int c = k-1;
                while(c>=0 && dist<erg[c]) { //MinPts >= 0 && Distanz zum i-ten Datenobjekt < erg[MinPts-1]
                    if(c<k-1){
                        erg[c+1] = erg[c];
                        result[c+1] = result[c];
                    }
                    erg[c] = dist;
                    result[c] = data[i];
                    c--;                  //MinPts um 1 reduzieren
                }
            }
        }//i
        return result;
    }
    
    
    public DataObject[] run(){
        initClusters();
        boolean clusterChangedf = assignPoints();
        for(int i = 0; i < cl.size(); i++){
            Cluster akt = (Cluster)cl.elementAt(i);
            //setMedian(akt, getObjects(akt));
        }
        boolean converged = false;
        int iter = 0;
        //for(int j = 0; j < 1; j++){
        while(!converged && iter < 2){
            for(int i = 0; i < cl.size(); i++){
                Cluster akt = (Cluster)cl.elementAt(i);
                //setMean(akt, getObjects(akt));
                setMedian(akt, getObjects(akt));
                DataObject[] obj = getObjects(akt);
                //if(obj.length > 10)
                findMainDirections(akt, obj);
            }
            boolean clusterChanged = assignPoints();
            mergeClusters();
            /*
            double costClustering = 0.0;
            System.out.print("Kosten");
            System.out.println();
            for(int i = 0; i < cl.size(); i++){
                Cluster akt = (Cluster)cl.elementAt(i);
                costClustering += akt.cost;
                System.out.println("Cluster " + akt.ID + " Zahl Obj " + akt.numObj + " Kosten " + akt.cost);
            }
            System.out.println("Iteration " + iter +  " " + cl.size() + " Clusters " + costClustering);
            if(!clusterChanged)
                converged = true;*/
            //}
            iter++;
        }
        System.out.println(iter + " Iterations");
        for(int i = 0; i < 10; i++){
            //mergeClusters();
            //assignPoints();
        }
        Cluster[] clusters = new Cluster[cl.size()];
        for(int i = 0; i < clusters.length; i++)
            clusters[i] = new Cluster();
        for(int i = 0; i < cl.size(); i++)
            clusters[i] = (Cluster)cl.elementAt(i);
        Clustering c = new Clustering(clusters, db.store);
        double costges = c.cost();
        System.out.println("Kosten " + costges);
       /* for(int i = 45; i < 100; i++){
            System.out.println(i + " coord " + db.store[i].coord[0] + " " + db.store[i].coord[1]);
            System.out.println(i + " " + db.store[i].clusterID + " cl0 " + clusterDistance(db.store[i], 0) + " cl1 " + clusterDistance(db.store[i], 1));
            System.out.println();
        }*/
        //mdlOutliers();
        return db.store;
    }
    
    //fr Bsp. Nr. 4
    public void artificialCross(){
        Cluster[] clusters = new Cluster[2];
        clusters[0] = new Cluster(1, 40, 2);
        clusters[1] = new Cluster(2, 50, 2);
        for(int i = 0; i < 40; i++)
            db.store[i].clusterID = 1;
        for(int i = 40; i< db.store.length; i++)
            db.store[i].clusterID = 2;
        for(int i = 0; i < clusters.length; i++){
            setMedian(clusters[i], getObjects(clusters[i]));
            findMainDirections(clusters[i], getObjects(clusters[i]));
        }
        cl.add(clusters[0]);
        cl.add(clusters[1]);
        mergeClusters();
        Clustering c = new Clustering(clusters, db.store);
        System.out.println("Kosten " + c.cost());
        Visu2D visu = new Visu2D(db.store, clusters, this);
        visu.setSize(600,600);
        visu.setLocation(100,0);
        visu.setVisible(true);
        
        
        /* Cluster[] clusters = new Cluster[1];
        clusters[0] = new Cluster(1, 90, 2);
        for(int i = 0; i < db.store.length; i++)
            db.store[i].clusterID = 1;
        for(int i = 0; i < clusters.length; i++){
            setMedian(clusters[i], getObjects(clusters[i]));
            findMainDirections(clusters[i], getObjects(clusters[i]));
        }
        cl.add(clusters[0]);
        mergeClusters();
        Clustering c = new Clustering(clusters, db.store);
        System.out.println("Kosten " + c.cost());
        Visu2D visu = new Visu2D(db.store, clusters, this);
        visu.setSize(600,600);
        visu.setLocation(100,0);
        visu.setVisible(true);*/
    }
    
    //fr GaussBsp
    public void gaussTest(){
        Cluster[] clusters = new Cluster[2];
        clusters[0] = new Cluster(1, 1000, 2);
        clusters[1] = new Cluster(2, 1000, 2);
        for(int i = 0; i < 1000; i++)
            db.store[i].clusterID = 1;
        for(int i = 1000; i< db.store.length; i++)
            db.store[i].clusterID = 2;
        for(int i = 0; i < clusters.length; i++){
            setMedian(clusters[i], getObjects(clusters[i]));
            findMainDirections(clusters[i], getObjects(clusters[i]));
        }
        cl.add(clusters[0]);
        cl.add(clusters[1]);
        //mergeClusters();
        Clustering c = new Clustering(clusters, db.store);
        c.clusterTest();
        System.out.println("Kosten " + c.cost());
        Visu2D visu = new Visu2D(db.store, clusters, this);
        visu.setSize(600,600);
        visu.setLocation(100,0);
        visu.setVisible(true);
    }
    
    public void icaTest(){
        Cluster[] clusters = new Cluster[1];
        clusters[0] = new Cluster(1, db.store.length, 2);
        for(int i = 0; i < clusters[0].numObj; i++)
            db.store[i].clusterID = 1;
        setMedian(clusters[0], getObjects(clusters[0]));
        //ICA
        double[][] coordObj = new double[clusters[0].numObj][dim];
        for(int i = 0; i < clusters[0].numObj; i++)
            for(int j = 0; j < dim; j++)
                coordObj[i][j] = db.store[i].coord[j];
        Ica ica = new Ica();
        double[][] w = ica.fastICA(coordObj);
        Matrix data = new Matrix(coordObj);
        Matrix dir = new Matrix(w);
        Matrix icaTrans = (data.times(dir.inverse())).transpose() ;
        double[][] tr_ica = icaTrans.getArrayCopy();
        DataObject[] transData_ica = new DataObject[clusters[0].numObj];
        for(int i = 0; i < transData_ica.length; i++){
            double[] c = new double[dim];
            for(int j = 0; j < dim; j++)
                c[j] = tr_ica[j][i];
            transData_ica[i] = new DataObject(c, i, 1);
        }
        //Kosten: Mittelwert berechnen
        double[] mean_ica = new double[dim];
        for(int i = 0; i < transData_ica.length; i++)
            for(int j = 0; j < dim; j++)
                mean_ica[j] += transData_ica[i].coord[j]/transData_ica.length;
        //logStar
        double ica_cost = 0.0;
        for(int i = 0; i < transData_ica.length; i++)
            for(int j = 0; j < dim; j++)
                ica_cost += logStar(transData_ica[i].coord[j], 1);
        
        //PCA
        EigenvalueDecomposition eig = new EigenvalueDecomposition(data);
        Matrix vectors = eig.getV();
        Matrix pcaTrans = vectors.transpose().times(data.transpose());
        double[][] tr_pca = pcaTrans.getArrayCopy();
        DataObject[] transData_pca = new DataObject[clusters[0].numObj];
        for(int i = 0; i < transData_pca.length; i++){
            double[] c = new double[dim];
            for(int j = 0; j < dim; j++)
                c[j] = tr_pca[j][i];
            transData_pca[i] = new DataObject(c, i, 2);
        }
        
         //Kosten: Mittelwert berechnen
        double[] mean_pca = new double[dim];
        for(int i = 0; i < transData_pca.length; i++)
            for(int j = 0; j < dim; j++)
                mean_pca[j] += transData_pca[i].coord[j]/transData_pca.length;
        //logStar
        double pca_cost = 0.0;
        for(int i = 0; i < transData_pca.length; i++)
            for(int j = 0; j < dim; j++)
                pca_cost += logStar(transData_pca[i].coord[j], 1);
        System.out.println("Cost ICA " + ica_cost);
        System.out.println("Cost PCA " + pca_cost);
        
        VisuSimple vs_ica = new VisuSimple(transData_ica);
        vs_ica.setSize(600,600);
        vs_ica.setLocation(100,0);
        vs_ica.setVisible(true);
        
        VisuSimple vs_pca = new VisuSimple(transData_pca);
        vs_pca.setSize(600,600);
        vs_pca.setLocation(200,0);
        vs_pca.setVisible(true);
    }
    
    public void mdlOutliers(){
        for(int i = 0; i < db.store.length; i++){
            int aktID = db.store[i].clusterID-1;
            Cluster aktCl = (Cluster)cl.elementAt(aktID);
            if(!db.store[i].payOff(aktCl))
                db.store[i].clusterID = 0;
        }
    }
    
    
    public void initClusters(){
        Random r = new Random();
        for(int i = 0; i < sampleSize; i++){
            int nextMean = r.nextInt(db.store.length);
            Cluster c = new Cluster(db.store[nextMean].coord, (i+1), this.dim);
            cl.add(c);
        }
    }
    
    
    public boolean assignPoints(){
        System.out.println();
        System.out.println("assignPoints to " + cl.size() + " clusters.");
        boolean clusterChanged = false;
        for(int i = 0; i < db.store.length; i++){
            int oldID = db.store[i].clusterID;
            double minDist = Double.MAX_VALUE;
            int minIndex = 0;
            for(int j = 0; j < cl.size(); j++){
                double aktDist = clusterDistance(db.store[i], j);
                if (aktDist < minDist){
                    minDist = aktDist;
                    minIndex = j;
                }
            }
            if(oldID != ((Cluster)cl.elementAt(minIndex)).ID)
                clusterChanged = true;
            db.store[i].clusterID = ((Cluster)cl.elementAt(minIndex)).ID;
        }
        for(int i = 0; i < cl.size(); i++){
            int counter = 0;
            for(int j = 0; j < db.store.length; j++){
                if(db.store[j].clusterID == ((Cluster)cl.elementAt(i)).ID){
                    counter++;
                }
            }
            
            ((Cluster)cl.elementAt(i)).setNumObj(counter);
        }
        for(int i = 0; i < cl.size(); i++){
            Cluster akt = (Cluster)cl.elementAt(i);
            if(akt.numObj == 0)
                cl.remove(akt);
        }
        return clusterChanged;
    }
    
    public int assignObject(double[] coord){
        DataObject assObj = new DataObject(coord, db.store.length);
        double minDist = Double.MAX_VALUE;
        int minIndex = 0;
        for(int j = 0; j < cl.size(); j++){
            double aktDist = clusterDistance(assObj, j);
            if (aktDist < minDist){
                minDist = aktDist;
                minIndex = j;
            }
        }
        return ((Cluster)cl.elementAt(minIndex)).ID;
    }
    
    
    public void mergeClusters(){
        System.out.println("Merging clusters.");
        boolean improvement = true;
        boolean merged = false;
        int mergedNum = 0;
        for(int i = 0; i < cl.size(); i++)
            setCost((Cluster)cl.elementAt(i), getObjects((Cluster)cl.elementAt(i)));
        //whloop: while(cl.size() > 1 && improvement){
        double savedCost = 0.0;
        int[] index = new int[2];
        Cluster newCl = new Cluster();
        for(int i = 0; i < cl.size(); i++){
            for(int j = 0; j < cl.size(); j++){
                Cluster c_i = (Cluster)cl.elementAt(i);
                Cluster c_j = (Cluster)cl.elementAt(j);
                if(i != j){
                    DataObject[] mergedData = new DataObject[c_i.numObj + c_j.numObj];
                    int c = 0;
                    for(int k = 0; k < db.store.length; k++){
                        if(db.store[k].clusterID == c_i.ID || db.store[k].clusterID == c_j.ID){
                            mergedData[c] = db.store[k];
                            c++;
                        }
                    }
                    int minID = Math.min(c_i.ID, c_j.ID);
                    Cluster m = new Cluster(minID, c, dim);
                    //setMean(m, mergedData);
                    setMedian(m, mergedData);
                    findMainDirections(m, mergedData);
                    setCost(m, mergedData);
                    m.cost = m.cost - mergedData.length; //je ein Bit durch ClusterID weniger
                    double saved = (c_i.cost + c_j.cost) - m.cost;
                    if(saved > savedCost){
                        savedCost = saved;
                        index[0] = i;
                        index[1] = j;
                        newCl = m;
                    }
                }  //if
            } //j
        } // i
        if(savedCost == 0)
            improvement = false;
        else{
            Cluster c_i = (Cluster)cl.elementAt(index[0]);
            Cluster c_j = (Cluster)cl.elementAt(index[1]);
            System.out.println("Verschmelze Cluster " + c_i.ID + " und  " + c_j.ID);
            cl.remove(c_i);
            cl.remove(c_j);
            cl.add(newCl);
            mergedNum++;
            merged = true;
            int minID = Math.min(c_i.ID, c_j.ID);
            if(c_i.ID > minID){
                for(int l = 0; l < db.store.length; l++)
                    if(db.store[l].clusterID == c_i.ID)
                        db.store[l].clusterID = minID;
            } else{
                for(int l = 0; l < db.store.length; l++)
                    if(db.store[l].clusterID == c_j.ID)
                        db.store[l].clusterID = minID;
            }
        }
        //}    //while
        System.out.println(mergedNum + " Clusters merged.");
    }
    
    private void setMean(Cluster c, DataObject[] members){
        double[] mean = new double[dim];
        for(int i = 0; i < members.length; i++)
            for(int j = 0; j < dim; j++)
                mean[j] += members[i].coord[j]/members.length;
        c.setMean(mean);
    }
    
    public void setMedian(Cluster c, DataObject[] members) {
        int numObj= members.length ;
        int dim = members[0].coord.length ;
        c.mean = new double[dim];
        double [] sortarray = new double[numObj] ;
        for (int i=0 ; i<dim ; i++) {
            double median = 0.0 ;
            for (int j=0 ; j<numObj ; j++)
                sortarray[j]=members[j].coord[i] ;
            Arrays.sort(sortarray) ;
            if (numObj==1)
                c.mean[i]=sortarray[0] ;
            else if (numObj%2 == 0)
                c.mean[i]=(sortarray[numObj/2-1]+sortarray[numObj/2])/2 ;
            else
                c.mean[i]=(sortarray[numObj/2-1]+sortarray[numObj/2]+sortarray[numObj/2+1])/3 ;
        }
    }
    
    
    private double clusterDistance(DataObject d, int i){
        Cluster c = (Cluster)cl.elementAt(i);
        if(c.eigenVector == null)
            return d.distance(c.mean);
        else{
            double[] subspaceCoord = new double[c.dim];
            for(int j = 0; j < dim; j++){
                for(int k = 0; k < dim; k++){
                    subspaceCoord[j] += (d.coord[k]-c.mean[k]) * c.eigenVector[k][j] * c.invEigenValue[k];
                }
            }
            return distance(new double[dim], subspaceCoord);
        }
    }
    
    private double distance(double[] mean, double[] d){
        double sum = 0.0;
        for (int i = 0; i < d.length; i++){
            double dist = ((d[i] - mean[i])*(d[i] - mean[i]));
            sum = sum + dist;
        }
        return Math.sqrt(sum);
    }
    
    private DataObject[] getObjects(Cluster c){
        DataObject[] members = new DataObject[c.numObj];
        int counter = 0;
        for(int j = 0; j < db.store.length; j++)
            if(db.store[j].clusterID == c.ID){
            members[counter] = db.store[j];
            counter++;
            }
        return members;
    }
    
    private double[][] setCovariance(DataObject[] data, double[] mean){
        double[][] cov = new double[dim][dim];
        for(int l = 0; l < data.length; l++)
            for(int i = 0; i < dim; i++)
                for(int j = 0; j < dim; j++)
                    cov[i][j]+= (data[l].coord[j]-mean[j])*(data[l].coord[i]-mean[i]);
        for(int i = 0; i < dim; i++)
            for(int j = 0; j < dim; j++)
                cov[i][j]/= data.length;
        return cov;
    }
    
    public double[][] covarByMedian(DataObject[] data, double[] mean) {
        int numObj= data.length ;
        int dim = data[0].coord.length ;
        double [] sortarray = new double[numObj] ;
        double[][] cov = new double[dim][dim];
        if (numObj <15){
            for (int i=0 ; i<dim ; i++)
                cov[i][i]=1.0 ;
            return cov ;
        }
        for(int l1 = 0; l1 < dim; l1++) {
            for(int l2 = 0; l2 < dim; l2++) {
                for(int j = 0; j < numObj; j++)
                    sortarray[j] = (data[j].coord[l1]-mean[l1])*(data[j].coord[l2]-mean[l2]) ;
                
                Arrays.sort(sortarray) ;
                if (numObj%2 == 0)
                    
                    cov[l1][l2]=(sortarray[numObj/2-1]+sortarray[numObj/2])/2 ;
                else
                    
                    cov[l1][l2]=(sortarray[numObj/2-1]+sortarray[numObj/2]+sortarray[numObj/2+1])/3
                            ;
            }
            
        }
        double maxdiff = 0.0 ;
        for (int i=0 ; i<dim ; i++){
            double sum = 0.0 ;
            for (int j=0 ; j<dim ; j++)
                sum += Math.abs(cov[i][j]) ;
            double diff = 1.1*sum - 2.1*cov[i][i] ;
            if (diff>maxdiff)
                maxdiff = diff ;
        }
        if (maxdiff > 0.0)
            for (int i=0 ; i<dim ; i++)
                cov[i][i] += maxdiff ;
        
        return cov ;
    }
    
    public void findMainDirections(Cluster c, DataObject[] members){
        System.out.println();
        DataObject[] knn;
        System.out.println("Cluster " + c.ID + " Zahl Obj " + members.length);
        if(members.length > 20){
            DataObject center = new DataObject(c.mean);
            knn = knn(members, center, 3*members.length/4);
        } else{
            knn = members;
        }
        System.out.println("knn " + knn.length);
        //Matrix cov = new Matrix(setCovariance(knn, c.mean));
        Matrix cov = new Matrix(covarByMedian(knn, c.mean));
        System.out.println("Kovarianzmatrix");
        cov.print(5, 3);
        EigenvalueDecomposition e = new EigenvalueDecomposition(cov);
        Matrix vectors = e.getV();
        System.out.println("Eigenvektoren:");
        vectors.print(5, 3);
        Matrix values = e.getD();
        System.out.println("EW:");
        values.print(5, 3);
        double[][] ev = vectors.getArrayCopy();
        double[][] ew = values.getArrayCopy();
        double[] eigenValues = new double[dim];
        for(int k = 0; k < dim; k++)
            eigenValues[k] = ew[k][k];
        c.setEigenValue(eigenValues);
        //transponieren
       /* for(int k = 0; k < ev.length; k++)
            for(int l = 0; l < ev.length; l++)
                if(k < l)
                    ev[k][l] = ev[l][k];*/
        c.setEigenVector(ev);
        System.out.print("IEW: ");
        for(int i = 0; i < c.invEigenValue.length; i++)
            System.out.print(c.invEigenValue[i] + " ");
        //mdlSub(c, members);
    }
    
    
    
    private void setCost(Cluster c, DataObject[] members){
        //Kosten fr Mittelwert
        double costMean = 0.0;
        for(int i = 0; i < c.mean.length; i++)
            costMean += logStar(c.mean[i], 1);
        // Kosten als normaler Cluster
        double costNormal = 0.0;
        //Kosten fr Koordinaten
        for(int i = 0; i < members.length; i++)
            for(int j = 0; j < dim; j++)
                costNormal += logStar((members[i].coord[j]-c.mean[j]), 1);
        costNormal += costMean;
        //Kosten fr EV
        /*for(int i = 0; i < dim; i++){
            for(int j = 0; j < dim; j++)
                costNormal+= logStar(c.eigenVector[i][j], 3);
        }*/
        
        //Kosten als subspace cluster
        double costSubspace = 0.0;
        double[][] transCoord = new double[c.numObj][dim];
        for(int i = 0; i < members.length; i++){
            for(int j = 0; j < dim; j++){
                for(int k = 0; k < dim; k++){
                    transCoord[i][j] += (members[i].coord[j]-c.mean[j]) * c.eigenVector[j][k];
                }
            }
        }
        //Kosten fr Koordinaten
        for(int i = 0; i < transCoord.length; i++)
            for(int j = 0; j < transCoord[i].length; j++)
                costSubspace += logStar(transCoord[i][j], 1);
        //Kosten fr EV
        for(int i = 0; i < dim; i++){
            for(int j = 0; j < dim; j++)
                costSubspace+= logStar(c.eigenVector[i][j], 3);
        }
        //Kosten fr Mittelwert
        costSubspace += costMean;
        if(costNormal > costSubspace)
            c.subspaceCluster = true;
        else
            c.subspaceCluster = false;
        c.cost = Math.min(costNormal, costSubspace);
        System.out.println();
        System.out.println("Cluster " + c.ID + " Kosten normal " + costNormal + " Kosten subspace " + costSubspace);
    }
    
    
    private double mdlSub(Cluster c, DataObject[] members){
        System.out.println();
        System.out.println("bewerte Cluster " + c.ID);
        double[][] transCoord = new double[c.numObj][dim];
        for(int i = 0; i < members.length; i++){
            for(int j = 0; j < dim; j++){
                for(int k = 0; k < dim; k++){
                    transCoord[i][j] += (members[i].coord[j]-c.mean[j]) * c.eigenVector[j][k];
                }
            }
        }
        double lstar = 0.0;
        for(int i = 0; i < transCoord.length; i++)
            for(int j = 0; j < transCoord[i].length; j++)
                lstar += logStar(transCoord[i][j], 1);
        System.out.println("Koordinaten mdl subspace " + lstar);
        double lnorm = 0.0;
        for(int i = 0; i < members.length; i++)
            for(int j = 0; j < dim; j++)
                lnorm += logStar((members[i].coord[j]-c.mean[j]), 1);
        System.out.println("Koodinaten mdl gesamtraum " + lnorm);
        double n = 0.0;
        for(int i = 0; i < members.length; i++)
            for(int j = 0; j < dim; j++)
                n += logStar(members[i].coord[j], 1);
        //System.out.println("mdl gesamtraum " + n);
        for(int i = 0; i < dim; i++){
            for(int j = 0; j < dim; j++)
                lstar+= logStar(c.eigenVector[i][j], 3);
        }
        System.out.println("Kosten mit Eigenvektoren " + lstar);
        return lstar;
    }
    
    public double logStar(double cc, int precision){
        double c = Math.pow(10.0, precision) * Math.abs(cc) ;
        double result = 0.0;
        // while (c > 0){
        c = Math.log(c)/Math.log(2);
        if(c > 0)
            result += c;
        //}
        return result;
    }
    
    public double logStarClustered(DataObject d, DataObject med){
        double sum = 0.0;
        for(int i = 0; i < d.coord.length; i++)
            sum+= logStar(Math.abs(d.coord[i]-med.coord[i]), 1);
        return sum;
    }
    
    
    public double logStar(int cc){
        double c = Math.abs(cc) ;
        double result = 0.0;
        //while (c > 0){
        c = Math.log(c)/Math.log(2);
        if(c > 0)
            result += c;
        //}
        return result;
    }
}

