/*
 * Generator.java
 *
 * Created on August 29, 2006, 1:25 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package dataGenerator;
import java.util.Random;
import visu.DistributionPlot;
import visu.VisuSimple;
import visu.VisuInfo;
import compr.DataObject;

/**
 *
 * @author Administrator
 */
public class Generator {
    int numObj;
    double[] mu;
    double[] sigma;
    double[] beta;
    int dim;
    Random r;
    
    
    /** Creates a new instance of Generator */
    public Generator(int numObj, double[] mu, double[] sigma, double[] beta) {
        this.numObj = numObj;
        this.mu = mu;
        this.sigma = sigma;
        this.beta = beta;
        dim = mu.length;
        r = new Random();
    }
    
    public Generator(int numObj){
        this.numObj = numObj;
    }
    
    public double[] generateCoordinates(double m, double s, double b){
        GeneralizedGaussian gg = new GeneralizedGaussian(m, s, b);
        double[] ggValues = new double[numObj];
        double[] randomIndices = new double[numObj];
        for(int i = 0; i < numObj; i++){
            double nextRandom = r.nextDouble();
            randomIndices[i] = nextRandom;
            ggValues[i] = gg.px(nextRandom);
        }
        
        SortObject so = new SortObject();
        SortObject[] sArray = so.createAndSort(ggValues, randomIndices);
        double[] result = new double[numObj];
        for(int i = 0; i < sArray.length; i++)
            result[i] = sArray[i].ggValue;
        //return result;
         
        return ggValues;
    }
    
    public DataObject[] Cluster(){
        DataObject[] d = new DataObject[numObj];
        for(int i = 0; i < d.length; i++)
            d[i] = new DataObject(1, 2);
        for(int i = 0; i < dim; i++){
            double[] coord_i = generateCoordinates(mu[i], sigma[i], beta[i]);
            for(int j = 0; j < numObj; j++)
                d[j].coord[i] = coord_i[j];
        }
        return d;
    }
    
    public void outputStatistics(DataObject[] d){
        Statistics s = new Statistics();
        for(int i = 0; i < d[0].coord.length; i++){
            System.out.println("coordinate " + i);
            double mean = s.mean(d, i);
            System.out.println("mean " + mean);
            System.out.println("variance " + s.variance(d, i, mean));
            System.out.println("min " + s.minCoord(d, i) + " max " + s.maxCoord(d, i));
            System.out.println();
        }
    }
    
    public void outputStatistics(double[] d){
        Statistics s = new Statistics();
            double mean = s.mean(d);
            System.out.println("mean " + mean);
            System.out.println("variance " + s.variance(d,mean));
            System.out.println("min " + s.minCoord(d) + " max " + s.maxCoord(d));
            System.out.println();
    }
    
    
    
    
    /**
     * @param args the command line arguments
     *
     */
    public static void main(String[] args) {
        double[] mu = new double[2];
        mu[0] = 0.0;
        mu[1] = 0.0;
        double[] sigma = new double[2];
        sigma[0] = 1.0;
        sigma[1] = 1.0;
        double[] beta = new double[2];
        beta[0] = -0.89;
        beta[1] = -0.89;
        
        
        double[][] mixingMatrix = new double[2][2];
        Generator g = new Generator(5000, mu, sigma, beta);
        DataObject[] data = g.Cluster();
        g.outputStatistics(data);
        
        VisuInfo vs = new VisuInfo(data, "d");
        vs.setSize(500,550);
        vs.setLocation(100,100);
        vs.setVisible(true);
        
        
/*
        Generator g = new Generator(1000);
        double[] data = g.generateCoordinates(0.5, 0.1, -0.80);
        g.outputStatistics(data);
        DistributionPlot d = new DistributionPlot(data);
        
        d.setSize(1005,550);
        d.setLocation(100,100);
        d.setVisible(true);
  */   
    }
    
}
