package eval;
import Jama.*;


/**
 * Cost of clusters without parameter cost.
 * @author Administrator
 */
public class Cluster implements Cloneable{
    public int ID;
    public double cost;
    boolean subspaceCluster;
    public boolean noiseCluster;
    public double costID;
    public double[][] dir;
    public double[][] invDir;
    public double[] mean;
    public double[] var;
    public int[] dist;
    public int distr;                  //distribution
    int dim;
    public double[] lb;
    public double[] ub;
    public int numObj;
    
    
    public Cluster(){
        cost = 0.0;
        numObj = 0;
    }
    
    
     public Cluster(int id){
        this.ID = id;
    }
     
     public Cluster(int dim, int ID){
         this.ID = ID;
         this.dim = dim;
         cost = 0.0;
         numObj = 0;
         invDir = new double[dim][dim];
         mean = new double[dim];
         var = new double[dim];
     }
     
     public Cluster(Cluster c){
         ID = c.ID;
         cost = c.cost;
         subspaceCluster = c.subspaceCluster;
         dir = c.dir;
         invDir = c.invDir;
         mean = c.mean;
         var = c.var;
         dist = c.dist;
         dim = c.dim;
         numObj = c.numObj;
     }
    
      public Cluster(double[] lb, double[] ub){
        this.lb = lb; 
        this.ub = ub;
    }
    
    public Cluster(double[][] dir){
        this.dir = dir;
    }
    
    
    /** Creates a new instance of Cluster */
    public Cluster(double[] mean, int id, int dim) {
        this.dim = dim;
        this.mean = mean;
        this.var = new double[dim];
        this.ID = id;
    }
    
    public Cluster(int id, int numObj, int dim){
        this.dim = dim;
        this.ID = id;
        this.var = new double[dim];
        this.numObj = numObj;
    }
    
    public void setNumObj(int num){
        numObj = num;
    }
    
    public Object clone(){
        try{
            return super.clone();
        } catch (CloneNotSupportedException e){
            throw new InternalError();
        }
    }
    
    public void setMean(double[] mean){
        this.mean = mean;
    }
    
    
    
    
    
}


