package gengauss;
/*
 * EpdMineo.java
 *
 * Created on 5. Juli 2007, 15:20
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */
import umontreal.iro.lecuyer.util.Num ;

/**
 *
 * @author boehm
 */
public class EpdMineo {
    
    /** Creates a new instance of EpdMineo */
    public EpdMineo() {
    }
    
    static boolean verbose = false ;
    static boolean vverb = false ;
    static boolean correctSigma = false ;
    public static double minSigma = 0.001 ;
    
    static double c(double beta) {
        return(Math.pow(Math.exp(Num.lnGamma(0.15E1+0.15E1*beta))/Math.exp(Num.lnGamma(0.5+0.5*beta)),1/(1+
                beta)));
    }
    
    public static double mu(double[] sample, double p, double lb, double ub) {
        double limit = 0.001*(ub-lb) ;
        double mean = 0.5*(ub+lb) ;
        while (ub-lb > limit) {
            if (verbose)
                System.out.print(mean+", ");
            double sum = 0.0 ;
            for (int i=0 ; i<sample.length ; i++){
                if (sample[i] > mean)
                    sum += Math.pow(sample[i] - mean, p-1.0) ;
                else
                    sum -= Math.pow(mean - sample[i], p-1.0) ;
            }
            if (sum > 0)
                lb = mean ;
            else
                ub = mean ;
            mean = 0.5*(ub+lb) ;
        }
        if (verbose) System.out.println() ;
        return mean ;
    }
    
    public static double sigma(double[] sample, double mu, double p) {
        double sum = 0.0 ;
        for (int i=0 ; i<sample.length ; i++)
            sum += Math.pow(Math.abs(sample[i]-mu), p) ;
        return Math.max (minSigma, Math.pow(sum/sample.length, 1.0/p) ) ;
    }
    
    public static double dldp(double[] sample, double mu, double sigma, double p) {
        double sum = 0.0 ;
        double logsum = 0.0 ;
        int n = sample.length ;
        for (int i=0 ; i<n ; i++) {
            double h = Math.abs(sample[i] - mu) ;
            double h2 = Math.pow(h, p) ;
            sum += h2 ;
            logsum += h2 * Math.log(h) ;
        }
        double t1 = Math.log(p) + Num.digamma(1.0+1.0/p) - 1.0 ;
        double pp = p*p ;
        double sigma_p = Math.pow(sigma,p) ;
        //return sum / pp / sigma_p + (Math.log (sigma) * sum - logsum) / p / sigma_p - sample.length * t1 / pp ;
        return (n*Math.log(p)-n+n*Num.digamma(1/p)+n*p-p/sigma_p*logsum+sum/sigma_p+sum*Math.log(sigma)*p/sigma_p)/pp ;
    }
    
    public static double loglikelihood(double [] sample, double mu, double sigma, double p) {
        double sum = 0.0 ;
        for (int i=0 ; i<sample.length ; i++)
            sum += Math.pow(Math.abs(sample[i]-mu), p) ;
        //TEST
        //System.out.println("p " + p); //negativ: -0.35
        double t = 1+1/p;
        //System.out.println("t:" + t); //negativ: -1.82
        double d = Num.lnGamma(1+1/p);
        //TEST
        return -sample.length*(Math.log(2*Math.pow(p, 1/p)*sigma)+Num.lnGamma(1+1/p)) - sum/p/Math.pow(sigma, p) ;
        //return Math.pow (2*Math.pow (p, 1/p) * sigma * Num.gamma (1+1/p), sample.length) * Math.exp (-sum/p/Math.pow(sigma, p)) ;
    }
    
    public static void optLLH(double [] sample, double beta, double lb, double ub) {
        double p = 2.0/(1+beta) ;
        double mu = mu(sample, p, lb, ub) ;
        double sigma = sigma(sample, mu, p) ;
        System.out.println(mu+", "+sigma+", "+beta+", "+p+", "+loglikelihood(sample, mu, sigma, p)+", "+dldp(sample, mu, sigma, p)) ;
    }
    
    public static double quantile(double [] arr, int k) {
        double [] cost = arr.clone() ;
        int l = 0 ;
        int r = cost.length - 1 ;
        while (r>l) {
            int i = partition(cost, l, r) ;
            if (i >= k) r = i-1 ;
            if (i <= k) l = i+1 ;
        }
        return cost[r] ;
    }
    
    public static int partition(double [] cost, int l, int r) {
        int i = l-1 ;
        int j = r ;
        double v = cost[r] ;
        for (;;) {
            while (cost[++i] < v) ;
            while (v < cost[--j]) if (j==l) break ;
            if (i >= j) break ;
            double h = cost[i] ;
            cost[i] = cost[j] ;
            cost[j] = h ;
        }
        double h = cost[i] ;
        cost[i] = cost[r] ;
        cost[r] = h ;
        return i ;
    }
    
    public static double [] optimizeHelp(double [] sample, double lb, double ub, double betaL, double betaU, double betaF) {
        double mean = 0.5*(betaL+betaU) ;
        double p = 2/(1+mean) ;
        double mu = mu(sample, p, lb, ub) ;
        double sigma = sigma(sample, mu, p) ;
        while (betaU-betaL > betaF) {
            if (verbose)
                System.out.println("--->"+mu+", "+sigma*Math.pow(c(mean)*p,1/p)+", "+mean) ;
            if (dldp(sample, mu, sigma, p) > 0) {
                betaU = mean ;
            } else {
                betaL = mean ;
            }
            mean = 0.5*(betaL+betaU) ;
            p = 2/(1+mean) ;
            mu = mu(sample, p, lb, ub) ;
            sigma = sigma(sample, mu, p) ;
        }
        if (correctSigma)
            sigma = Math.pow    (    Math.pow(sigma, p) * sample.length / Math.max (sample.length-p/2, 1),   1/p) ;
        
        double help = loglikelihood (sample, mu, sigma, p) ;
        
        sigma *= Math.pow(c(mean)*p,1/p) ;
        
        double [] r = {mu, sigma, mean, help} ;
        return r ;
    }
    
    public static double [] optimizeMSP(double [] sample) {
        if (vverb){
            printAllMSP(sample) ;
            vverb = false ;
        }
        int n = sample.length ;
        double lb = sample [0] ;
        double ub = sample [0] ;
        for (int i=1 ; i<n ; i++) {
            double h = sample[i] ;
            lb = Math.min(lb, h) ;
            ub = Math.max(ub, h) ;
        }
        double [] r1 = optimizeHelp(sample, lb, ub, -0.97, 0.0, 0.001) ;
        double [] r2 = optimizeHelp(sample, lb, ub, 0.0, 1.0, 0.001) ;
        double [] r3 = optimizeHelp(sample, lb, ub, 1.0, 5.0, 0.001) ;
        
        if (r1[3] >= r2[3] && r1[3] >= r3[3])
            return r1 ;
        if (r2[3] >= r1[3] && r2[3] >= r3[3])
            return r2 ;
        return r3 ;
    }
    
    public static double [] optimizeMSP_old(double [] sample) {
        if (vverb){
            printAllMSP(sample) ;
            vverb = false ;
        }
        double betaL = -0.97 ;
        double betaU = 5 ;
        double betaF = 0.001 ;
        int n = sample.length ;
        double lb = sample [0] ;
        double ub = sample [0] ;
        for (int i=1 ; i<n ; i++) {
            double h = sample[i] ;
            lb = Math.min(lb, h) ;
            ub = Math.max(ub, h) ;
        }
        double mean = 0.5*(betaL+betaU) ;
        double p = 2/(1+mean) ;
        double mu = mu(sample, p, lb, ub) ;
        double sigma = sigma(sample, mu, p) ;
        while (betaU-betaL > betaF) {
            if (verbose)
                System.out.println("--->"+mu+", "+sigma*Math.pow(c(mean)*p,1/p)+", "+mean) ;
            if (dldp(sample, mu, sigma, p) > 0) {
                betaU = mean ;
            } else {
                betaL = mean ;
            }
            mean = 0.5*(betaL+betaU) ;
            p = 2/(1+mean) ;
            mu = mu(sample, p, lb, ub) ;
            sigma = sigma(sample, mu, p) ;
        }
        double [] r = {mu, sigma*Math.pow(c(mean)*p,1/p), mean} ;
        return r ;
    }
    
    public static void printAllMSP(double [] sample) {
        double betaL = -0.97 ;
        double betaU = 5 ;
        double betaF = 0.001 ;
        int n = sample.length ;
        double lb = sample [0] ;
        double ub = sample [0] ;
        for (int i=1 ; i<n ; i++) {
            double h = sample[i] ;
            lb = Math.min(lb, h) ;
            ub = Math.max(ub, h) ;
        }
        for (double mean = betaL ; mean < betaU ; mean += 0.1) {
            double p = 2/(1+mean) ;
            double mu = mu(sample, p, lb, ub) ;
            double sigma = sigma(sample, mu, p) ;
            double h = dldp(sample, mu, sigma, p) ;
            System.out.println(mu+", "+sigma+", "+mean+", "+h+", "+loglikelihood(sample, mu, sigma, p) ) ;
        }
    }
}
