/*
 * Test.java
 *
 * Created on 30. Mai 2006, 13:40
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package ica;
import java.util.*;
import io.IO;
import compr.DataObject;

/**
 *
 * @author boehm
 */
public class Test {
    static double ln10 = Math.log(10);
    static double ln2 = Math.log(2);
    
    /** Creates a new instance of Test */
    public Test() {
    }
    
    public void entropyTest(){
        int precision = 3;
        int num = 1000;
        Random r = new Random(5);
        IO ea = new IO();
        double uniformCost = 0.0;
        double gaussCost = 0.0;
        double laplaceCost = 0.0;
        for(int i = 0; i < num; i++){
            uniformCost += uniformCost(r.nextDouble(), 0, 1, precision);
            gaussCost+= gaussCost(r.nextGaussian(), 0.0, 1.0, precision); 
            laplaceCost += laplaceCost(ea.nextLaplacian(0.0, Math.sqrt(0.5), r), 0.0, 1.0, precision);
        }
        System.out.println("uniform cost " + uniformCost + " gaussCost " + gaussCost + " laplaceCost " + laplaceCost);          
    }
    /*
    public void clusterTest(DataObject[] data){
        //all objects in Cluster not rotated
        double sumUniform = 0.0;
        double sumGauss = 0.0;
        double sumLaplace = 0.0;
        
        for(int i = 0; i < data.length; i++)
            
            
            
    }
    */
    
    private double uniformCost(double x, double lb, double ub, int precision){
        double prob ;
        if (Math.abs(ub-lb) < Math.pow(10, -precision))
            prob = 1 ;
        else
            prob = Math.pow(10, -precision) / Math.abs(ub - lb) ;
        return Math.log(1/prob)/Math.log(2);
    }
    
    private double gaussCost(double x, double mean, double var, int precision){
       /* double pdf = Math.exp(-(x-mean)*(x-mean)/2.0/(std * std))/Math.sqrt(2 * Math.PI * std * std);
        double prob = pdf * Math.pow(10, -precision) ;
        if (std<4*Math.pow(10, -precision))
            System.err.println("Attention, resolution too large") ;*/
        double va = Math.max(var, Double.MIN_VALUE) ;
        return Math.max(0.0,(0.5*Math.log(2*Math.PI*va)+precision*ln10+Math.pow(x-mean,2)/2/va)/ln2 );
        
        //return Math.log(1/prob)/Math.log(2);
    }
    
    private double laplaceCost(double x, double mean, double var, int precision){
        double stdv = Math.sqrt(var);
        double b = stdv/Math.sqrt(2);
        if (b<Math.pow(10, -precision)/10)
            return 0 ;
        double pdf = 1/(2*b)*Math.exp(-Math.abs(x-mean)/b);
        double prob = Math.max(Double.MIN_VALUE, Math.min(1.0, pdf * Math.pow(10, -precision)));
        //return 100000;
        return Math.log(1.0/prob)/Math.log(2);
    }
    
}
