/*
 * VisuLOF.java
 *
 * Created on 23. November 2005, 17:24
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package visu;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import javax.swing.*;
import compr.*;


/**
 *
 * @author boehm
 */
public class VisuLOF extends javax.swing.JFrame {
    DataObject[] clustered;
    double[] lof;
    int clusterPoint;
    
    
    
    // innere Klasse f�r Zeichenfl�che
    private class Leinwand extends JPanel {
        public void paintComponent(Graphics g) {
            super.paintComponent(g);
            
            //int x,y;
            
            Graphics2D g2 = (Graphics2D) g;
            g2.setStroke(new BasicStroke(6.0f));
            //Koordinatensystem
            Line2D.Float y = new Line2D.Float(10.0f, 0.0f, 10.0f, 500.0f);
            Line2D.Float x = new Line2D.Float(10.0f, 500.0f, 500.0f, 500.0f);
            //g2.draw(y);
            //g2.draw(x);
            //g2.setStroke(new BasicStroke(6.0f));
            
            //hier zeichnen, Koordinaten normieren
            //boolean[] lofValues = lofValues(0.1);
            boolean[] lofValues = lofTopK(30);
            
            double max_x = -Double.MAX_VALUE;
            double max_y = -Double.MAX_VALUE;
            double min_x = Double.MAX_VALUE;
            double min_y = Double.MAX_VALUE;
            for(int i = 0; i < clustered.length; i++){
                if(clustered[i].coord[0] > max_x){
                    max_x = clustered[i].coord[0];
                }
                if(clustered[i].coord[1] > max_y){
                    max_y = clustered[i].coord[1];
                }
                if(clustered[i].coord[0] < min_x){
                    min_x = clustered[i].coord[0];
                }
                if(clustered[i].coord[1] < min_y){
                    min_y = clustered[i].coord[1];
                }
            }
            //System.out.println(" max_x-min_x " + (max_x-min_x));
            //System.out.println(" max_y-min_y " + (max_y-min_y));
            for(int i = 0; i < clustered.length; i++){
                float xCoord = (float) ((clustered[i].coord[0]-min_x)/(max_x-min_x) * 500);
                float yCoord = (float) (500 - (clustered[i].coord[1]-min_y)/(max_y-min_y) * 500);
                //System.out.println("X " + xCoord + " Y" + yCoord);
                Line2D.Float akt = new Line2D.Float(xCoord, yCoord, xCoord, yCoord);
                float xo = (float)(xCoord+5);
                float xu = (float)(xCoord-5);
                float yu = (float)(yCoord+5);
                float yo = (float)(yCoord-5);
                if(lofValues[i]){
                    g2.setColor(Color.BLACK);
                    if(clustered[i].classID != 4)
                        clusterPoint++;
                } 
                else{
                    g2.setColor(Color.LIGHT_GRAY);
                }
                g2.draw(akt);
            }
            System.out.println("clusterPoints assigned to outliers: " + clusterPoint);
        }
        
        //cutOff : how large, e. g. 0.8*max_LOF
        private boolean[] lofValues(double cutOff){
            double maxLOF = 0.0;
            double minLOF = Double.MAX_VALUE;
            boolean[] lofValues = new boolean[lof.length];
            for(int i = 0; i < lof.length; i++){
                if(lof[i]<minLOF)
                    minLOF = lof[i];
                if(lof[i]>maxLOF)
                    maxLOF = lof[i];
            }
            System.out.println("maxLOF " + maxLOF);
            System.out.println("minLOF " + minLOF);
            for(int i = 0; i < lof.length; i++)
                if(lof[i]> cutOff*maxLOF)
                    lofValues[i] = true;
            return lofValues;
        }
        
        private boolean[] lofTopK(int topK){
            boolean[] lofValues = new boolean[lof.length];
            for(int i = 0; i < topK; i++){
                double maxLOF = 0.0;
                int maxIndex = 0;
                for(int j = 0; j < lof.length; j++){
                    if(lof[j]>maxLOF && !lofValues[j]){
                        maxLOF = lof[j];
                        maxIndex = j;
                    }
                }
                lofValues[maxIndex] = true;
            }
            return lofValues;
        }
        
    }
    public VisuLOF(DataObject[] store, double[] lof){
        if(store[0].coord.length > 2){
            PCA p = new PCA(store);
            DataObject[] reduced = p.pca(2);
            this.clustered = reduced;
        } else{
            this.clustered = store;
        }
        clusterPoint = 0;
        this.lof = lof;
        for(int i = 0; i < lof.length; i++)
            System.out.println("dataObject: " + store[i].number + " lof: " + lof[i]);
        // Hauptfenster einrichten
        setTitle("VisuLOF");
        Leinwand l = new Leinwand();
        l.setBackground(Color.WHITE);
        getContentPane().add(l, BorderLayout.CENTER);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
}

